︠bdbb3646-99e4-48ca-9ba8-8f2fed0f86fci︠
%md
# Math 152: Intro to Mathematical Software
### 2017-03-03
### Kiran Kedlaya; University of California, San Diego
### adapted from lectures by William Stein, University of Washington


## **Lecture 22: Plotting: Matplotlib Pyplot vs Sage vs MATLAB**

︡70e03e40-9a05-428f-83b3-b56d801d9744︡{"done":true,"md":"# Math 152: Intro to Mathematical Software\n### 2017-03-03\n### Kiran Kedlaya; University of California, San Diego\n### adapted from lectures by William Stein, University of Washington\n\n\n## **Lecture 22: Plotting: Matplotlib Pyplot vs Sage vs MATLAB**"}
︠b47224ed-55b9-46ca-8e50-ca0c98618e37i︠
%md
We follow http://matplotlib.org/users/pyplot_tutorial.html, and shows how to use the MATLAB-stype interface to matplotlib.
We will cover topics:

 - plot: plotting a list of values
 - array of plots: axes and figures
︡1739b431-557b-420e-bec9-3a5b0cb8297b︡{"done":true,"md":"We follow http://matplotlib.org/users/pyplot_tutorial.html, and shows how to use the MATLAB-stype interface to matplotlib.\nWe will cover topics:\n\n - plot: plotting a list of values\n - array of plots: axes and figures"}
︠d1c71866-fbba-486f-bb07-3a6a3714abd8s︠
%auto
import numpy as np
import matplotlib.pyplot as plt
︡c32ed009-eed2-4f71-8905-20f0e8339d37︡{"done":true}
︠4bb43c3f-c0fd-4d52-81fa-df00c19fc40ei︠
%md
### 1. Plot
︡875da88b-6ef5-43cf-a63f-0d33b7016f67︡{"done":true,"md":"### 1. Plot"}
︠8528f50a-3596-49da-8e14-15c07d1c2c36s︠
plt.plot([1,2,3,10])
plt.show()
︡9bac4fa0-1d0f-4049-906b-eaab30c2dccd︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f991f0b1450>]"}︡{"stdout":"\n"}︡{"file":{"filename":"fd96c56f-df9c-43dd-994f-4b3c03b31977.svg","show":true,"text":null,"uuid":"f6d35ece-e92a-449f-8eb1-a2005dbb4ad7"},"once":false}︡{"done":true}︡
︠a3dd925e-0a00-4b0b-976d-d6b22ab014bei︠
%md
MPL's `plt.plot` is VERY different than Sage's plot!

`plt.plot(x values, y yalues, options, [repeat])`
︡a1fc9a9d-b328-434c-9006-f66342ac3f23︡{"done":true,"md":"MPL's `plt.plot` is VERY different than Sage's plot!\n\n`plt.plot(x values, y yalues, options, [repeat])`"}
︠5ab20613-e7f2-46f3-a3a9-4d512cea40d5s︠
plt.plot([1,2,3,10], [0,2,4,6],[0,1,2,3],[2,5,5,7], 'ro-')
plt.show()
︡76fcd103-d171-4b24-8373-6b6b282245ae︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f991e1704d0>, <matplotlib.lines.Line2D object at 0x7f991e1706d0>]\n"}︡{"file":{"filename":"bd555803-2be1-42a1-828b-f19c8192c851.svg","show":true,"text":null,"uuid":"4699cdca-5036-4985-b131-f93ab9ce78ac"},"once":false}︡{"done":true}︡
︠881d2cb5-368e-4f70-8445-ad49c4fbcd0ds︠
zip([2,3,4],[1,2,3],[0,0,1])
︡7ca78d93-de94-4b0f-850c-279b00ebcae2︡{"stdout":"[(2, 1, 0), (3, 2, 0), (4, 3, 1)]\n"}︡{"done":true}︡
︠1e37e1f3-faf3-42f7-a7f5-d0ecccb09ceei︠
%md
In Sage, you use the `line` command instead, and have to put the points together (using zip).

Also, in Sage, use `frame=True` to draw a frame instead of $x,y$-axes.

︡916cd967-59a1-4a6f-b543-b5cde5d6073c︡{"done":true,"md":"In Sage, you use the `line` command instead, and have to put the points together (using zip).\n\nAlso, in Sage, use `frame=True` to draw a frame instead of $x,y$-axes."}
︠175c2248-be54-47bd-945b-58adbfa6fe89s︠
show( line(zip([1,2,3,10], [0,2,4,6],[0,1,2,3]), color='red', marker='o'), frame=True)
︡20b52744-159f-4a46-b1ee-653a9d25cec9︡{"file":{"filename":"bc41330d-719a-4105-a46a-ad6eb2a00ce0.sage3d","uuid":"bc41330d-719a-4105-a46a-ad6eb2a00ce0"}}︡{"done":true}︡
︠9a6bfdc6-b876-49eb-a0e0-6fee6f0bed0as︠
# Another example with two curves:

x = np.linspace(-2*np.pi, 2*np.pi, 200)    # remember from wednesday
y1 = np.sin(x)                        # apply function to array is entry wise.
y2 = np.cos(x)

plt.plot(x,y1, x,y2)                  # give x and corresponding y's
plt.show()
︡85355080-4d97-4051-bcd0-ec75b26cd9d8︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f991e625a10>, <matplotlib.lines.Line2D object at 0x7f991e625ad0>]\n"}︡{"file":{"filename":"74683f44-c73e-41e6-a390-61884fd62b70.svg","show":true,"text":null,"uuid":"1afd3566-7c6b-4332-884b-ab89397587e8"},"once":false}︡{"done":true}︡
︠385a43a6-51a8-4e18-b48c-65317e35ad84i︠
%md
This is similar to MATLAB! -- see http://www.mathworks.com/help/matlab/ref/plot.html

<img src="matlab.png" width=600>
︡ec566fed-57f0-4f80-a343-b8e12e6ee149︡{"done":true,"md":"This is similar to MATLAB! -- see http://www.mathworks.com/help/matlab/ref/plot.html\n\n<img src=\"matlab.png\" width=600>"}
︠da176d67-0b14-4f45-b158-229b872a1ad3i︠
%md
Guess what this will do?
︡1d8f76e3-1710-482e-9d8f-dab4e6655f21︡{"done":true,"md":"Guess what this will do?"}
︠6273a42c-6e9e-4100-b175-465eff3149d7s︠

︡626f6e09-539a-4552-b7a6-30432e8a0c4e︡{"done":true}︡
︠a4be7741-4523-48cc-9155-322ada32c1fcs︠
t = np.arange(0, 5, 0.2)
plt.plot(t, t, 'r--', t, t**2, 'bs', t, t**3, 'g^')
plt.show()
︡37555a6f-a8ab-4dd6-9145-148459b49f38︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f991ea14fd0>, <matplotlib.lines.Line2D object at 0x7f991ea14990>, <matplotlib.lines.Line2D object at 0x7f991ea39890>]\n"}︡{"file":{"filename":"251a3487-cba7-431e-a123-2b5809f15f9d.svg","show":true,"text":null,"uuid":"5626fd9f-0354-4aac-834a-7b1716c7badb"},"once":false}︡{"done":true}︡
︠b94574ef-16ef-4146-beca-8673c0f7ff89i︠
%md
What will this do?
︡0958ad53-f274-4610-aec2-cda38004e6ba︡{"done":true,"md":"What will this do?"}
︠4b7cb74e-49ba-4bc7-979a-d1934ae3f471s︠
plt.plot(t, t**3 + t, 'g', linewidth=5)
plt.show()
︡2c56cd8e-4a9d-475e-924a-130aa80515fb︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f991e10d250>]\n"}︡{"file":{"filename":"7e889df9-3b75-4e81-bbec-09cb00f293e8.svg","show":true,"text":null,"uuid":"548e5dff-5118-4f4b-a2c5-1e98c41967dc"},"once":false}︡{"done":true}︡
︠25ffbd77-8dba-467f-856f-b7a4c5cee300i︠
%md
**Exercise:**
Plot the polynomial $x^4 + 2x - 1$ using both matplotlib and Sage's plot commands, for $-3\leq x \leq 3$.
︡b5d93949-b776-4c16-be08-dd07739569e0︡{"done":true,"md":"**Exercise:**\nPlot the polynomial $x^4 + 2x - 1$ using both matplotlib and Sage's plot commands, for $-3\\leq x \\leq 3$."}
︠3b9d6986-9290-464f-bfd1-9b8d0d9f012e︠

︡6ae1fcb0-ce8a-45db-82b6-2fbdf2551e7b︡
︠cbdc1d00-2840-4627-84dc-f2fc7d5d70d9︠

︡6fd9e65c-45ad-4b7a-a09e-2a4ae0fa893f︡
︠d3bcd36b-97a2-4ef9-b92e-6865325f82c2i︠
%md
### 2. Figures and Axes
︡58aa8165-a746-4ae9-89f8-f319d65dce95︡{"done":true,"md":"### 2. Figures and Axes"}
︠45c65b88-891e-4f1f-8571-337f5d3fae08s︠
def f(t):
    return np.exp(-t) * np.cos(2*np.pi*t)

def makefigure():
    t1 = np.arange(0, 5, 0.1)
    t2 = np.arange(0, 5, 0.02)

    plt.subplot(231)    # 2=numrows, 2=numcols, 1=fignum (which is from 1 to numrows*numcols)
    plt.plot(t1, f(t1), 'bo', t2, f(t2), 'k')

    plt.subplot(232)    # 2=numrows, 2=numcols, 2=fignum... (yes, MATLAB is horrible.)
    plt.plot(t2, np.cos(2*np.pi*t2), 'r--')

    plt.subplot(234)    # 2=numrows, 2=numcols, 3=fignum
    plt.plot(t2, np.cos(2*np.pi*t2), 'r--')

    plt.subplot(236)    # 2=numrows, 2=numcols, 4=fignum
    plt.plot(t2, np.cos(2*np.pi*t2), 'r--')

    plt.show()

makefigure()
︡e99b4b31-30f0-423e-b699-e4e4472d9572︡{"file":{"filename":"7262c076-4691-486d-a26e-46465e64bf3a.svg","show":true,"text":null,"uuid":"cf8c1246-e99c-4bb8-b609-8bfb67180d21"},"once":false}︡{"done":true}︡
︠496cbb8c-172f-465b-9d3f-deddcb086678i︠
%md
**Exercise:** Copy the above code and instead make a 2x4 grid of plots (instead of a 2x2 grid).
Just put whatever plots you want in.
︡f8a32c12-6451-4294-bc7e-a21bd40663a4︡{"done":true,"md":"**Exercise:** Copy the above code and instead make a 2x4 grid of plots (instead of a 2x2 grid).\nJust put whatever plots you want in."}
︠ee303ca6-72ca-4567-82fd-501f3b444809︠
def f(t):
    return np.exp(-t) * np.cos(2*np.pi*t)

def makefigure():
    t1 = np.arange(0, 5, 0.1)
    t2 = np.arange(0, 5, 0.02)

    # MODIFY THIS CODE:

    plt.subplot(211)    # 2=numrows, 1=numcols, 1=fignum
    plt.plot(t1, f(t1), 'bo', t2, f(t2), 'k')

    plt.subplot(212)    # 2=numrows, 1=numcols, 2=fignum
    plt.plot(t2, np.cos(2*np.pi*t2), 'r--')

    plt.show()

makefigure()



︡1459b50f-5dbd-4116-a900-71dccf778b8d︡
︠f73e2f8f-ae8f-4700-8493-6042dba1c680i︠
%md
In Sage, there is graphics_array ([inspired by Mathematica...](https://reference.wolfram.com/language/ref/GraphicsGrid.html)) to do the above grid layout.
︡10b0cc07-0e79-4117-8a80-0c751834b934︡{"done":true,"md":"In Sage, there is graphics_array ([inspired by Mathematica...](https://reference.wolfram.com/language/ref/GraphicsGrid.html)) to do the above grid layout."}
︠94a5d06e-3994-4124-93de-0c6372120955s︠
%var t
g1 = plot(exp(-t)*cos(2*pi*t), 0, 5)
g2 = plot(cos(2*pi*t), 0, 5)
show(graphics_array([[g1,g2,g1], [g2,g1,g1]]), frame=True)
︡9a9fe5b9-251c-4843-8880-fbf2d68ed167︡{"file":{"filename":"/projects/8a2a5bba-2f6d-43ba-8570-fa9e4672e2b1/.sage/temp/compute5-us/6370/tmp_4_jWgF.svg","show":true,"text":null,"uuid":"d2fddb42-333d-4a95-b929-aae8ce0634b5"},"once":false}︡{"done":true}︡
︠d9ab2ed5-a4b4-47c3-8253-ee948fb849c8i︠
%md
**Exercise:** modify the above code to make a 2x2 array of plots using Sage plotting.
︡40466a5b-b7d9-42e4-9a5f-81368969bdcc︡{"done":true,"md":"**Exercise:** modify the above code to make a 2x2 array of plots using Sage plotting."}
︠4aaea0c8-ad28-45e0-94c4-ab79060e6c96︠
# EDIT ME!
%var t
g1 = plot(exp(-t)*cos(2*pi*t), 0, 5)
g2 = plot(cos(2*pi*t), 0, 5)
show(graphics_array([[g1], [g2]]), frame=True)
︡fff62444-6220-465b-a4f5-a591bfa03a86︡
︠1e49deff-fbab-4328-bbe8-26b592adc28e︠
%md
Adding text...
︡763966bd-c8f5-4221-a388-00b7acb23238︡
︠d6bb7510-a542-4e58-a3ba-374e75bea6f3s︠
t = np.arange(0, 5, 0.2)
plt.plot(t, t, 'r--', t, t**2, 'bs', t, t**3, 'g^')
plt.text(2, 40, 'this is some text')
plt.xlabel("This is the x axis", fontsize=10, color="blue")
plt.ylabel("And the y axis")
plt.title("This is an example: $x^3+e^x$")
plt.show()
︡1cccdc76-e0ba-4e1b-9946-052b5ad910c1︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f991e6a5fd0>, <matplotlib.lines.Line2D object at 0x7f991e69f210>, <matplotlib.lines.Line2D object at 0x7f991e69f850>]\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f991e4c1290>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f991e9e1350>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f991e3ea510>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f991eab7fd0>\n"}︡{"file":{"filename":"4128c141-6cac-4992-8ccc-3447570cfe32.svg","show":true,"text":null,"uuid":"3f181925-c9a8-4062-8aa2-36272e74db0b"},"once":false}︡{"done":true}︡
︠93b47ce5-32a1-4126-869b-b7833353f96fs︠

t = range(1,500,20)
u = [random() for i in t]
plt.plot(t, u)
plt.xscale('log')
plt.show()
︡71780698-738d-435f-9d2e-5552aa35f7e4︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f991e616d10>]\n"}︡{"file":{"filename":"4bec7203-c996-410b-8b2f-df89e0856a18.svg","show":true,"text":null,"uuid":"d7a8e79a-9e09-4b1c-adaf-7de194b2d7b1"},"once":false}︡{"done":true}︡
︠b94743fd-2c26-4e86-a539-341029c7c0c2︠









